// 22-01-2014
// test MAX141 OK .. avec /Shdn reli au +5 pour utiliser
// Vref externe =VDD au lieu de 2,5V
// car le LM335 sort 2830mV  la temperature ambiante 20C


#include"p18f26k22.h"
#define p18f26k22

#include <stdlib.h>
#include <stdio.h>
//#include <delays.h>
#include "../_common/Delays.h"
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>


// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F26K22
#define OSCILLATEUR_INTERNE
//#define WithPLL
#ifdef OSCILLATEUR_INTERNE
   #ifdef WithPLL
    #pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=ON            // CONFIG1H
   #else
    #pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H    
   #endif   
#else
#pragma config FOSC = HSHP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H
/*

=========== HARDWARE ====================
PIC 18F26k22  microchip  avec Bootoader install en fond de memoire

PortB
B0  21  input <--- Max1241  DOUT  
B1  22  
B2  23  
B3  24
B4  25
B5  26
B6  27
B7  28

PORTA
A0   2
A1   3
A2   4
A3   5 
A4   6  R + Led rouge
A5   7

PORTC
C0   11   output ->   Max1241 SCLK 
C1   12   output ->  Max1241 not CS
C2   13 
C3   14 
C4   15
C5   16 
C6   17  TX  RS232   UART Harware
C7   18  RX  RS232   UART Hardware
====================================================

*/



#ifndef Byte
#define Byte unsigned char
#endif

#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define Led_Rouge LATAbits.LATA4
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1
#define ETEINT 1
#define ALLUME 0

#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

#define Clock 0.25    // S   at 16Mhz

#define MAX1241
#ifdef MAX1241
#define MAX1241_CS      LATCbits.LATC0
#define MAX1241_CLCK    LATCbits.LATC1
#define MAX1241_OUT     PORTBbits.RB0
#define Ualim 3.30
/* hardware MAX1241
Pin1    VDD =3.3V
Pin2    Ain
Pin3    Not SHDN    reli au +5V =>inhibe ref interne
Pin4    Ref extern =VDD=3,3V
Pin5    Gnd
Pin6    Dout -> to RB0
Pin7    not CS  Chips selected if O level <- RC0
Pin8    SCLCK   <- RC1 

LM335
1 adjust
2 -- + Vout --- R 1K ---<+3,3V
3 0V
 
*/
#endif

rom const char chaine0[]="...";
rom const char chaine1[]="Oscill interne 16Mhz \r\n";
rom const char chaine2[]="C18: 18F26K22_Test_MAX1241_RS232_140121.c \r\n";
rom const char chaine3[]="Fosc interne 16Mhz \r\n";
rom const char chaine4[]=" \r\n";
rom const char chaine5[]=" \r\n";
// Attention sous VB6
// verifier l'ordre CRLF et non pas LFCR, sinon on voit 2 car non imprimable
// et pas de changement de ligne
rom char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5};


#pragma romdata EEP_=0xF00000

rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          "18F26K22_tests_divers.mcp     \r",//0
          "Init PorT Com RS232 19200bds. \r",//20  avec terminateur zero
          "................  <ESC> exit  \r",//40  avec terminateur zero
          "Avec UART HARDWARE........... \r",//60  avec terminateur zero
          "                              \r", //80  sans terminateur
          "paulfjujo@free.fr 08/01/2014 \r", //A0  sans terminateur
          "MPLAB IDE V8.90  C18 v3.45.01\r", //C0  avec terminateur
          "                          \r\n"  //D0 avec terminateur zero
          };
#pragma romdata

#pragma romdata EEP200_=0xF00200
rom unsigned char EEPROM_LCD_Msg [][20] ={
    "Test #5 Float2asc \0", // 0
    "18F26K22 C18 16MHz\0" // 20
    };
#pragma romdata

#define SIZE	80		/* taille buffer */		

#pragma udata GrossBank
static unsigned char buffer[SIZE];
#pragma udata




/*	Variables globales */

unsigned int count;
char Texte[SIZE]="18F26K22 ADC MAX1241";  // 20 cars

char *txt;
unsigned char Entree[17]="1234567890123456";
Byte CRam1[32];
Byte CRam2[32];
unsigned unsigned char *valtxt;
unsigned char received;
unsigned char *ptlec;		// pointeur de lecture
unsigned char *ptecr;		// pointeur d'ecriture
volatile int CptFO,CptFE;           // compteur erreur UART
volatile unsigned char c;
unsigned int CptCars;
unsigned int SaisieOk;

Byte receive;
char error;
char EtatCf;
signed char Ve;
unsigned int  NbMes;
Byte Allume_led;
Byte Dummy;
unsigned int i,j,k,l ;
unsigned int ix,jx;
unsigned char s_count = 0;
unsigned int M,M1;
unsigned int EA0;
volatile unsigned char c1;
volatile unsigned int    DataReady1,ErrCom,i1;

unsigned int j1;
unsigned int count;
volatile unsigned int Over;
volatile unsigned long TimeEcoule;  // STATIC  car utilise dans interruption
volatile unsigned long OldTimeEcoule;
unsigned long Maxi;
unsigned long Mini;
unsigned long Cumul;  
float Delta, Moy, Volt ;
float F1,F2;


//unsigned char Drapeaux ;     // 8 flags

struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned Dummy:1;
                 unsigned Blc:1;
                 unsigned Change:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

 union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;

unsigned long Freq;
unsigned char *Decompose;


 
int PutStr_RS(char *s);
void Put_RS(char * untel);
void CRLF(void);
void Init_Hardware(void);
void Init_Timer1(void);
void configure_PORTC_CCP1 (void );
unsigned char *fltToa (float x, unsigned char *str,char precision);
void aligne8(void);
unsigned int Max1241_Read(void);

//--- interrupts
void Traite_ISR(void);

// ---- init  interruptions ------------------------
// Serial Interrupt
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Traite_ISR   _endasm
}
#pragma code

#pragma interrupt Traite_ISR
void Traite_ISR(void)	// reception d'une interruption
{
    //char c;
//==== UART interrupt ===========
if ( (PIE1bits.RC1IE == 1) &&(PIR1bits.RC1IF==1)) // si IT Rx UART
{
    c =Read1USART(); // le lire => RAZ  RCIF
   
     if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

   while( Busy1USART()) ; // par scurite
   //if (PORTBbits.RB1==0) Write1USART(c); // echo
	*ptecr++ = c;
	if (ptecr >= buffer+SIZE) ptecr = buffer;
	}
}
         

//--------- RS232 UART HARDWARE --------------

#ifdef DEBUG
void Tempo(long val)
{
  return;
 }   
 #else
void Tempo(long val)
{
while(val>0){val--;}
}
#endif


#ifdef MAX1241
unsigned int Max1241_Read()
{
 unsigned int i, k,Result;
 MAX1241_CLCK=0;
 MAX1241_CS=1;
 Delay_mS(5);
 MAX1241_CS=0;
Delay_uS(15);
 k=2048;
 Result=0;
 MAX1241_CLCK=1;
 for(i=0;i<12;i++)
 {
  Delay_uS(10);
  MAX1241_CLCK=0; 
  Delay_uS(10); 
  MAX1241_CLCK=1;
  if( MAX1241_OUT==1) Result=Result+k;
  k=k>>1;  
 }
 MAX1241_CS=1; 
  MAX1241_CLCK=0; 
 return (Result);
}
#endif


void Init_UART1(void)
{
// init 19200Bd 
// USART_BRGH_HIGH,32 @ 10MHZ 
// USART_BRGH_HIGH,51 @ 16MHZ 
// USART_BRGH_HIGH,25 @ 8MHZ 
// voir para 18.5 spec sheet DS41159B page 186
#ifdef OSCILLATEUR_INTERNE
  OSCCON=0b01110000;  //HFINTOSC  (16 MHz)
#endif
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
#ifdef OSCILLATEUR_INTERNE
 // USART_BRGH_HIGH,25    // 16MHz interne BRG16=0  38400bds
#ifdef WithPLL
   USART_BRGH_HIGH,208);  // 16MHzxPLL soit 64Mhz  interne BRG16=0  19200bds
   #else
   USART_BRGH_HIGH,51 ); // 16MHz interne BRG16=0  19200bds sans PLL
#endif   
 #else
  USART_BRGH_HIGH,32 );  // Q=10Mhz 19200bds
#endif
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // disable  des IT des priphriques
INTCONbits.GIE = 0 ; //  disable globale des IT
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

void Write_Word(unsigned int M,char Sign,char Bold)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=M;
        ultoa(M1,valtxt);
  }
  else itoa(M,valtxt);
 if (Drapeaux.Fill)
 {
  k=strlen(Entree);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Drapeaux.Blc) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
#ifdef NOKIA 
 if (Drapeaux.Lcd==1) nokia_print_str(valtxt,Bold); else k=PutStr_RS(valtxt);
 #else
 k=PutStr_RS(valtxt);
#endif
}



 unsigned char *fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }

// in f format, number of digits is related to size 
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ... 
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;					
if (x >= 10.0) {x = 1.0; ie++;} 
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);	
  x *= 10.0;	
  }
*str = '\0';
return (adpt);
}


void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
       Put_RS(49u);  //  '1'
    else
       Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')
    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')                       // '9'= 57u
    low += 7;                         // > '9'
   Put_RS(high);
   Put_RS(low);
   Put_RS('h');
 }


void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)
 {
  Put_RS(' ');
 }
}

//---- EEPROM PIC 18F 1Ko bytes  ================
unsigned char EEPROM_Lect(unsigned int adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned int adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned int PtrE);  // special for 18F46K22 1024 bytes EEPROM

//------  EEPROM du PIC18Fx6K22 ---------------

unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{  
 
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)&0x0003);   //Bits 2-7 are masked off since EEPROM is only 1KB
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
    EEADR =AdrE & 0xFF;
    EEADRH = (AdrE>>8)& 0x03;   //Bits 2-7 are masked off since EEPROM is only 1KB
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON1bits.CFGS =0;
  if(INTCONbits.GIE ==1)
    {
    INTCONbits.GIE =0 ;
    dr=1;
    }
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
	if (dr==1)INTCONbits.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
  do
  {
  if ( PtrE >1023) break;
  c = EEPROM_Lect(PtrE);
  if ( c==0) break;
  Put_RS(c);
  PtrE++;
  }
  while (c!=0)  ;
 Tempo(1000L);
}




void Init_Hardware()
 {
   ANSELB=0;
   PORTB = 0xFF;
   TRISB = 0xFF;
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=1;   	// B1 input for debug echo reception
   TRISBbits.TRISB2=0;   	// B2 led
   TRISBbits.TRISB3=1;		// B3 not used
   TRISBbits.TRISB4=1;		// B4 not used
   TRISBbits.TRISB5=1;		// B5 not used
   TRISBbits.TRISB6=1;       //  B6 not used
   TRISBbits.TRISB7=1;       //  B7 not used

      // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
  ADCON0 =0 ;
  ADCON1=0x07;           // No analog input on Port A
  TRISA = 0b00001111 ;   // PORTA is RA0,1,2,= Digital input  RA3,4,5=Digital output
  LATA = 0x00;
  
  ANSELC=0;
  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0b10000100;   
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 1; //RC2/CCP1 en entree
  TRISCbits.TRISC3 = 0;
  TRISCbits.TRISC4 = 0;
  TRISCbits.TRISC5 = 0;
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }



void aligne8()
{
 j=strlen(CRam1);
 while ( j<8)
 {
   k=fprintf(_H_USART,"x");   // replace "x" by " "
    j++;
  }
 k=fprintf(_H_USART,"%s%c",CRam1,9);
}

void main(void)
{
 
#ifdef OSCILLATEUR_INTERNE  
//  the internal oscillator is set to the default frequency of 1 MHz.
// The Internal Oscillator Frequency Select bits  (IRCF<2:0>)
// select the frequency output of the internal oscillator block  
// pour conserver 19200 bauds  16Mhz sinon retombe  1200 bauds
 OSCCON=0x60;         // Select8 MHz internal clock 
 // OSCCONbits.IRCF2=1; //HFINTOSC  (16 MHz)
 // OSCCONbits.IRCF1=1;
 // OSCCONbits.IRCF0=1;
 //OSCCONbits.SCS1=0;
 //OSCCONbits.SC0=0;
  OSCTUNE=0;
  
 #ifdef WithPLL 
    OSCTUNEbits.PLLEN=1;  // 1= avec PLL => 64Mhz ou 40Mhz
    #else
    OSCTUNEbits.PLLEN=0;  // 0 =sans PLL => 16Mhz  ou 10Mhz
   #endif  
#endif   
    
Init_Hardware() ;
Led_Rouge=0;

  

// init des pointeurs stockage reception car
 received=0;
 valtxt=&Entree[0];
 txt=&Texte[0];
 ErrCom=0;
 DataReady1=0;
 i1=0;
 buffer[0]=0;
 ptecr=buffer;
 ptlec= ptecr;
 
  Flags.Fanion=0;           // <- init globale des flags a Zero
  Flags.Drapeaux.Fill=1;    // <- init individuelle des flags
  Flags.Drapeaux.Blc=1;
  Flags.Drapeaux.Elligible=0; // inutile mais pour la comprehension
  Flags.Drapeaux.Change=0;
  Flags.Drapeaux.Dummy=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;

  CptFE=0;
  CptFO=0;

 Init_UART1();
 OUT_RS232
  
 Led_Rouge=1;
 Put_RS(CLS);
 Tempo(250000L);
 CptCars=0;
 count=0;
 CRLF();
 
 txt=&Texte[0];
 k=PutStr_RS(txt);
 CRLF();
 txt=&Texte[0];

 strcpypgm2ram(txt,RS_Str[1]);
 k=PutStr_RS(txt);
 Tempo(1000L) ;
  
 PrintOut_Eeprom_Msg(0);
 PrintOut_Eeprom_Msg(0x20);
 PrintOut_Eeprom_Msg(0x60);
 PrintOut_Eeprom_Msg(0xA0);
 PrintOut_Eeprom_Msg(0xC0);

 CRLF();
 Tempo(10000L) ;


 // test flottant to ascii 
 Volt=Ualim;
  k=fprintf(_H_USART,"Alim du Montage =3.3 V -> %s%c",fltToa(Volt,CRam1,4),9);
  CRLF(); 
 j=0;M=0;
 do
 { 
  //Tempo(100000L) ;
  Delay_mS(500);
  M1= Max1241_Read();
  M=M+M1;
 // Write_Word(k,0,0);
  Volt= (float)M1 * Ualim/4096.0;
  k=fprintf(_H_USART,"Lecture MAX1241 %05d soit %s Volts %c",M1,fltToa(Volt,CRam1,3),9);
 j++;
 if (j>15)
 {  // 0C = 273,15K  zero theorique du capteur 2730mV
    // *100 car  V*1000=>mV et 10mV/C
     Volt= ((float)(M>>4)* Ualim/4096.0 - 2.731)*100; 
     M=M>>4;
     k=fprintf(_H_USART,"Moy= %05d soit %s C",M,fltToa(Volt,CRam1,2));
     j=0;
     M=0;
 }    
 CRLF();
 }
 while(1);

 }

/*

18F26K22 ADC MAX1241
Oscill interne 16Mhz 
18F26K22_tests_divers.mcp     
Init PorT Com RS232 19200bds. 
Avec UART HARDWARE........... 
paulfjujo@free.fr 08/01/2014 
MPLAB IDE V8.90  C18 v3.45.01

Alim du Montage =3.3 V -> 3.3000	
Lecture MAX1241 03615 soit 2.912 Volts 	
Lecture MAX1241 03583 soit 2.887 Volts 	
Lecture MAX1241 03615 soit 2.912 Volts 	
Lecture MAX1241 03615 soit 2.912 Volts 	
Lecture MAX1241 03638 soit 2.931 Volts 	
Lecture MAX1241 03624 soit 2.920 Volts 	
Lecture MAX1241 03631 soit 2.925 Volts 	
Lecture MAX1241 03638 soit 2.931 Volts 	
Lecture MAX1241 03641 soit 2.933 Volts 	
Lecture MAX1241 03616 soit 2.913 Volts 	
Lecture MAX1241 03631 soit 2.925 Volts 	
Lecture MAX1241 03629 soit 2.924 Volts 	
Lecture MAX1241 03611 soit 2.909 Volts 	
Lecture MAX1241 03624 soit 2.920 Volts 	
Lecture MAX1241 03635 soit 2.929 Volts 	
Lecture MAX1241 03641 soit 2.933 Volts 	Moy= 03624 soit 18.87 C
Lecture MAX1241 03643 soit 2.935 Volts 	
Lecture MAX1241 03627 soit 2.922 Volts 	
Lecture MAX1241 03615 soit 2.912 Volts 	
Lecture MAX1241 03629 soit 2.924 Volts 	
Lecture MAX1241 03637 soit 2.930 Volts 	
Lecture MAX1241 03630 soit 2.925 Volts 	
Lecture MAX1241 03631 soit 2.925 Volts 	
Lecture MAX1241 03616 soit 2.913 Volts 	
Lecture MAX1241 03615 soit 2.912 Volts 	
Lecture MAX1241 03640 soit 2.933 Volts 	
Lecture MAX1241 03639 soit 2.932 Volts 	
Lecture MAX1241 03633 soit 2.927 Volts 	
Lecture MAX1241 03639 soit 2.932 Volts 	
Lecture MAX1241 03638 soit 2.931 Volts 	
Lecture MAX1241 03627 soit 2.922 Volts 	
Lecture MAX1241 03633 soit 2.927 Volts 	Moy= 03630 soit 19.36 C
Lecture MAX1241 03646 soit 2.937 Volts 	
Lecture MAX1241 03631 soit 2.925 Volts 
*/